;************************************************************
;*******  Autor: Dave Hankovec*******************************
;*******  Popis: Maticov klvesnice pro prehravac CD *******                          
;*******  Procesor: 89C2051  ********************************
;*********C 2005 ********************************************


$MOD51
$TITLE(BYTE SIGNED MULTIPLY)
$PAGEWIDTH(132)
$DEBUG
$OBJECT
$NOPAGING





;----------------Obsazeni RAM-----------------------
key	equ	30H 		;pocitadlo radek
klavesa	equ	31H		;ulozeny sejmuty kod - 
wait1	equ	32H
Wait2	equ	33H
cifra_1	equ	34H	
cifra_2	equ	35H	
;-------------
cele_cislo	equ	36H	;
posuv		equ	38H


;----------------Bitove promenne--------------------------------
cifra		bit	0	;povoleni klavesy ENTER



  ORG        0000H
  JMP        Init
  ORG        0030H 

init:
;setting UART
	mov	th0,#03Ch
	mov	tl0,#0B8h
	mov	th1,#253
	mov	tl1,#253
	mov	scon,#01010000b
	mov	tmod,#00100001b		; spustime seriovy kanal 9600b,8b,1S,None
	setb TR1

	
;============================================================
; hlavn smycka
;============================================================


	clr	cifra		;bude prvni cifra
	jmp	naraznik


keyboard:

	MOV        P1, #00001111B             ; nastaven vstup a vstup
	MOV        Key, #1D 


opet: 
 	MOV	posuv,#11101111B             ; poten nastaven vstup
  	MOV        P1, posuv             ; poten nastaven vstup

Sloupec:
  	JNB        P1.3, Stisk               ; test 1.sloupce                  
  	CALL       Key_plus_1                 ; Key = Key + 1
Sloupec2:
  	JNB        P1.2, Stisk                ; test 2.sloupce  
  	CALL       Key_plus_1                 ; Key = Key + 1
Sloupec3:
  	JNB        P1.1, Stisk                ; test 3.sloupce  
  	CALL       Key_plus_1                 ; Key = Key + 1

   	SETB       C
  	MOV        A, posuv
  	RLC        A                          ; posuv portu 
  	mov	   posuv,A
  	MOV        P1, A
  	CJNE       A, #11111111B, Sloupec           ; skok jestlie byly testovny vechny klvesy
  	JMP        Konec_cyklu


Stisk:                                  
	MOV        B, P1
	CALL       Cekej_1ms
	MOV        A, P1
	clr	C
	SUBB       A, B
	JNZ        keyboard     		;neshoda - zakmit
	MOV	klavesa,key		
	jmp	keyboard 	
						;skace na zacatek, pokud je drzena klavesa, pri uvolneni dojede na konec
						;vystoupi z rutiny a v klavesa je kod
Konec_cyklu:
   	


;zde konec vycitani klavesnice


	mov	A,klavesa
	cjne	A,#0FFH,platny_kod	;test narazniku, pokud je FFH, nestlacena klavesa - nedela nic
	jmp	keyboard		;opakovani, nebyla klavesa



platny_kod:				;klavesa byla stlacena, kod (reprezentace pro displej) je v -klavesa-
;-------------------------stisknuto cislo, uloz do promennych--------------------
	cjne	A,#0AH,pokr_01
	mov	R0,#0			;stisknuto cislo pred nulou vlevo (mezi vyvody 18 a 19) - to bude STOP
odeslani:
	call	vysilani		;odesleme
	clr	cifra			;priste bude prvni cifra
	jmp	naraznik		;zpet na klavesnici


pokr_01:
	cjne	A,#0CH,pokr_02		;0CH je kod pro EJECT
	mov	R0,#65H			;kod pro eject
	jmp	odeslani

pokr_02:
	cjne	A,#0BH,pokr_03
	clr	A			;stisknuta klavesa 0

pokr_03:
	jb	cifra,uloz_druhou	;ulozeno do prvni cifry
	mov	cifra_1,A
	setb	cifra
	jmp	naraznik

uloz_druhou:
	clr	cifra
	mov	cifra_2,A	;uloz druhou cifru / jednotky
;-------------------------------------------------
;nyni prevest na hexa
	mov	A,cifra_1
	jnb	Acc.0,test1  		;desitky
	mov	A,cifra_2
    	add	A,#10D  
	mov	cifra_2,A
test1: 
   	mov	A,cifra_1
	jnb	Acc.1,test2 
    	mov	A,cifra_2
	add	A,#20D
	mov	cifra_2,A
test2:
    	mov	A,cifra_1
	jnb	Acc.2,test3  
    	mov	A,cifra_2
	add	A,#40D  
	mov	cifra_2,A
test3:
    	mov	A,cifra_1
	jnb	Acc.3,prevedeno  
    	mov	A,cifra_2
	add	A,#80D  
	mov	cifra_2,A
prevedeno:
;prevedeno, odesleme
	mov	R0,cifra_2
	call	vysilani
	jmp	naraznik













;============================================================  
key_plus_1:
  INC	key		;zvys klavesu o 1
  RET 

cekej_1ms:
  MOV        Wait1, #250D
  MOV        Wait2, #2D
loop2:
  DJNZ       Wait1, Loop2
  DJNZ       Wait2, Loop2
  RET
;============================================================

;-------Obnovi hodnotu narazniku pri nestlacene klavese-------------------
naraznik:
	mov	klavesa,#0FFH
	jmp	keyboard

;============================================================
vysilani:  
          clr ti                  ;nulovn pznaku dokonenho odvysln
          mov sbuf,r0             ;vysln obsahu R0
          jnb ti,$                ;ekn na odvysln
          clr ti                  ;nulovn pznaku dokonenho odvysln
          ret

;============================================================
; nastaven promnnch
;============================================================
kod_klavesy:

  DB         01H,02H,03H	;1,2,3
  DB         04H,05H,06H	;4,5,6
  DB         07H,08H,09H,	;7,8,9
  DB         0AH,0BH,0CH	;CR,0,ESC
  

  END
